VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPuzzle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private colSize             As Integer
Private rowSize             As Integer
Private cellCount           As Integer
Private mark                As Boolean
Private canvass             As PictureBox
Private imgSource           As PictureBox
Private selector            As PictureBox
Private click(1)            As Integer
Private cell()              As clsCell
Private pictureSelection    As PictureConstants
Public onPlay               As Boolean


Private Sub Class_Initialize()
    colSize = INITIAL_COLSIZE
    rowSize = INITIAL_ROWSIZE
    cellCount = colSize * rowSize
    pictureSelection = WOODY
    onPlay = False
End Sub

Public Sub initialize(ByRef newCanvass As PictureBox, ByRef newImgSource As PictureBox, ByRef newSelector As PictureBox)
    Set canvass = newCanvass
    Set imgSource = newImgSource
    Set selector = newSelector
    loadImages
End Sub

Public Property Let setColSize(ByVal newColSize As Integer)
    colSize = newColSize
    cellCount = colSize * rowSize
End Property

Public Property Get getColSize() As Integer
    getColSize = colSize
End Property

Public Property Let setRowSize(ByVal newRowSize As Integer)
    rowSize = newRowSize
    cellCount = colSize * rowSize
End Property

Public Property Get getRowSize() As Integer
    getRowSize = rowSize
End Property

Public Property Let setPictureSelection(ByVal newPictureSelection As PictureConstants)
    pictureSelection = newPictureSelection
End Property

Public Property Get getPictureSelection() As PictureConstants
    getPictureSelection = pictureSelection
End Property

Public Property Let setMark(ByVal newIndex As Integer, ByVal newMark As Boolean)
    
    mark = newMark
    
    If newMark = True Then
        ' This is the first click
        click(0) = newIndex
        drawCellImage newIndex, vbDstInvert
        
    Else
        ' This is the second click
        click(1) = newIndex
        drawCellImage click(0), vbSrcCopy
                       
        ' Swap the images
        Dim tempIndex   As Integer
        
        tempIndex = cell(click(0)).getImageIndex
        cell(click(0)).setImageIndex = cell(click(1)).getImageIndex
        cell(click(1)).setImageIndex = tempIndex
        
        drawCellImage click(0), vbSrcCopy
        drawCellImage click(1), vbSrcCopy
        
    End If
    
End Property

Public Property Get getMark() As Boolean
    getMark = mark
End Property

Private Sub initializeCells()

    Dim row         As Integer
    Dim col         As Integer
    Dim cellCtr     As Integer
    Dim cellWidth   As Integer
    Dim cellHeight  As Integer
    
    ReDim cell(cellCount - 1) As clsCell

    cellWidth = IMAGE_WIDTH / colSize
    cellHeight = IMAGE_HEIGHT / rowSize

    For row = 1 To rowSize
        For col = 1 To colSize
            Set cell(cellCtr) = New clsCell
            cell(cellCtr).setWidth = cellWidth
            cell(cellCtr).setHeight = cellHeight
            cell(cellCtr).setLeft = (col - 1) * cellWidth
            cell(cellCtr).setTop = (row - 1) * cellHeight
            cell(cellCtr).setImageIndex = cellCtr
            cell(cellCtr).setIndex = cellCtr
            cellCtr = cellCtr + 1
        Next
    Next

End Sub

Private Sub shuffleImageIndexes()

    Dim cellMarked()    As Boolean
    Dim index           As Integer
    Dim ctr             As Integer
    
    ReDim cellMarked(cellCount - 1) As Boolean
    
    Do
        Do
            Randomize (Format(Time, "ss"))
            index = CInt(Rnd * (cellCount - 1))
        Loop Until cellMarked(index) = False
        
        cellMarked(index) = True
        cell(ctr).setImageIndex = index
        ctr = ctr + 1
        
    Loop Until done(cellMarked)

End Sub

Private Function done(ByVal marked As Variant) As Boolean

    Dim i   As Integer
    done = True
    For i = 0 To UBound(marked)
        If marked(i) = False Then
            done = False
            Exit Function
        End If
    Next

End Function

Private Sub setImages()

    Dim col         As Integer
    Dim row         As Integer
    Dim ctr         As Integer
    
    canvass.Picture = LoadPicture(EMPTY_STRING)
    selector.FillStyle = vbFSSolid
    
    For row = 1 To rowSize
        For col = 1 To colSize
            
            drawCellImage ctr, vbSrcCopy
            
            selector.FillColor = RGB(ctr, ctr, ctr)
            Rectangle selector.hdc, _
                      cell(ctr).getLeft, _
                      cell(ctr).getTop, _
                      cell(ctr).getLeft + cell(ctr).getWidth, _
                      cell(ctr).getTop + cell(ctr).getHeight
            
            ctr = ctr + 1
            
        Next
    Next

    canvass.Refresh
    onPlay = True

End Sub

Private Sub drawCellImage(ByVal cIndex As Integer, ByVal rasterOp As Long)

    BitBlt canvass.hdc, _
           cell(cIndex).getLeft, _
           cell(cIndex).getTop, _
           cell(cIndex).getWidth, _
           cell(cIndex).getHeight, _
           imgSource.hdc, _
           cell(cell(cIndex).getImageIndex).getLeft, _
           cell(cell(cIndex).getImageIndex).getTop, _
           rasterOp
           canvass.Refresh

End Sub

Public Sub shuffleCells()
    
    initializeCells
    shuffleImageIndexes
    setImages
    
End Sub

Public Sub loadImages()
    imgSource.Picture = LoadResPicture(RES_BASE + pictureSelection, vbResBitmap)
    canvass.Picture = LoadResPicture(RES_BASE + pictureSelection, vbResBitmap)
    selector.width = imgSource.width
    selector.height = imgSource.height
End Sub

Public Function solved() As Boolean

    Dim i   As Integer
    solved = True
    For i = 0 To cellCount - 1
        If cell(i).getImageIndex <> cell(i).getIndex Then
            solved = False
            Exit Function
        End If
    Next

End Function

Private Sub Class_Terminate()
    
    On Error Resume Next
    Dim i           As Integer
    
    For i = 0 To cellCount - 1
        Set cell(i) = Nothing
    Next
    
End Sub
